<template>
  <div style="display: flex; align-items: center">
    <v-select
      :disabled="advanced"
      :style="havePermission ? 'max-width:96%' : 'max-width:100%'"
      v-model="selectedToSendMessage"
      :items="showAll"
      item-text="fullname"
      item-value="id"
      :label="sendToMsg"
      prepend-icon="mdi-email-outline"
      chips
      deletable-chips
      multiple
    >
      <template v-slot:selection="{ item, index }">
        <span v-if="selectedToSendMessage.length !== showAll.length">
          <v-chip v-if="index < 6" class="mr-0" small>
            <span>{{ item.fullname }}</span>
          </v-chip>
          <span
            v-if="index === 5 && selectedToSendMessage.length > 6"
            class="ml-1 grey--text caption"
            >(+{{ selectedToSendMessage.length - 6 }} pessoas)</span
          >
        </span>
        <span v-else>
          <v-chip v-if="index === 0" class="mr-0" small>
            <span>Todos selecionados</span>
          </v-chip>
          <span v-if="index === 0" class="ml-1 grey--text caption"
            >({{ selectedToSendMessage.length }} pessoas)</span
          >
        </span>
      </template>
      <template v-slot:prepend-item>
        <v-list-item ripple @click="toggle">
          <v-list-item-action>
            <v-icon :color="selectedToSendMessage.length > 0 ? 'indigo darken-4' : ''">
              {{ icon }}
            </v-icon>
          </v-list-item-action>
          <v-list-item-content>
            <v-list-item-title>Todos</v-list-item-title>
          </v-list-item-content>
        </v-list-item>
        <v-divider class="mt-2"></v-divider>
      </template>
    </v-select>
    <v-menu
      v-if="havePermission"
      v-model="menu"
      :close-on-content-click="false"
      :nudge-width="150"
      transition="slide-y-transition"
      offset-overflow
    >
      <template v-slot:activator="{ on }">
        <v-btn
          icon
          class="mx-0"
          v-on="on"
          :color="selectAllEntities || searchEntities ? 'primary' : ''"
        >
          <v-tooltip color="primary" bottom :nudge-bottom="-7">
            <template v-slot:activator="{ on }">
              <v-icon v-on="on">mdi-email-edit</v-icon>
            </template>
            <span style="font-size:0.8rem">Editar opções avançadas de envio</span>
          </v-tooltip>
        </v-btn>
      </template>
      <v-card>
        <v-list class="px-8">
          <v-list-item-content>
            <v-list-item-title>
              <div style="text-align:center; font-size: 0.9rem">
                <v-icon class="pr-2" color="primary">mdi-email-edit</v-icon
                ><b>Opções avançadas de envio</b>
              </div>
            </v-list-item-title>
          </v-list-item-content>
          <v-divider />
        </v-list>
        <v-list>
          <v-list-item @click="allParentsActive">
            <v-list-item-title style="font-size: 0.9rem">
              Para esta e entidades filhas ativas
              <v-icon class="pb-1" small v-if="selectAllEntities">mdi-check</v-icon>
            </v-list-item-title>
          </v-list-item>
          <v-list-item @click="selectEntities">
            <v-list-item-title style="font-size: 0.9rem">
              Selecionar entidades
              <v-icon class="pb-1" small v-if="searchEntities">mdi-check</v-icon>
            </v-list-item-title>
          </v-list-item>
          <v-list-item v-if="searchEntities">
            <v-list-item-title style="font-size: 0.9rem">
              <div v-if="searchEntities" class="maxHeightSelectEntities">
                <v-checkbox
                  v-for="entity in allEntities"
                  :key="entity.id"
                  v-model="selectedEntities"
                  :label="entity.name"
                  :value="entity.id"
                  @click="emitSelectedEntities"
                ></v-checkbox>
              </div>
            </v-list-item-title>
          </v-list-item>
          <v-list-item @click="sendToDefault">
            <v-list-item-title style="font-size: 0.9rem"
              >(Restaurar padrão de envio)
            </v-list-item-title>
          </v-list-item>
        </v-list>
      </v-card>
    </v-menu>
  </div>
</template>

<script>
import Management from '../../services/management'
import User from '../../services/user'

export default {
  name: 'SelectMessageTo',
  computed: {
    resetMailTo() {
      return this.$store.state.user.resetMailTo
    },
    selectedAll() {
      return this.selectedToSendMessage.length === this.showAll.length
    },
    onlySelected() {
      return this.selectedToSendMessage.length > 0 && !this.selectedAll
    },
    icon() {
      if (this.selectedAll) return 'mdi-close-box'
      if (this.onlySelected) return 'mdi-minus-box'
      return 'mdi-checkbox-blank-outline'
    },
  },
  data: () => ({
    sendToMsg: 'Enviar para',
    selectedToSendMessage: [],
    selectedEntity: '',
    menu: false,
    advanced: false,
    showAll: [],
    selectAllEntities: false,
    searchEntities: false,
    allEntities: [],
    selectedEntities: [],
    havePermission: false,
  }),
  async created() {
    await this.checkPermissions()
    await this.init()
    await this.lerEntidadeFilhas()
  },
  watch: {
    selectedToSendMessage() {
      this.$emit('selectedIds', this.selectedToSendMessage)
    },
    resetMailTo() {
      if (this.resetMailTo == true) {
        this.selectedToSendMessage = []
        this.toggle()
        this.advanced = false
        this.searchEntities = false
        this.selectAllEntities = false
        this.selectedEntities = []
        this.sendToMsg = 'Enviar para'
        this.$store.commit('user/UPDATE_RESET_MAIL_TO', false)
      }
    },
  },
  methods: {
    async checkPermissions() {
      const actionsMap = this.$store.state.user.mappedActions
      if (actionsMap.get('readEntityByName')) this.havePermission = true
    },

    //INICIO INTEGRAÇÃO BACKEND
    //método init: seleciona inicialmente todos os usuários da entidade.
    async init() {
      const userLogged = await this.$getItem('userInfo')
      const userLoggediD = userLogged.id
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('userRead').id

      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Management.readUsersByPage(entityId, actionId, { page: 1, skip: 500000 })
        if (ret.success) {
          let users = ret.data.users.filter((user) => {
            let check = false
            user.entities.forEach((entity) => {
              if (entity.entity == entityId) check = true
            })
            if (check) {
              user.fullname = `${user.name} ${user.surname}`
              return user
            }
          })
          this.showAll = users

          this.toggle()
        }
      } catch (e) {
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
    //FIM INTEGRAÇÃO BACKEND
    handleAdvanced() {
      this.advanced = !this.advanced
      this.selectedToSendMessage = []
      if (this.advanced) {
        this.sendToMsg = 'Opções avançadas de envio'
      }
      if (!this.advanced) {
        this.sendToMsg = 'Enviar para'
        this.toggle()
      }
    },
    toggle() {
      this.$nextTick(() => {
        if (this.onlySelected) {
          this.selectedToSendMessage = []
        }
        if (this.selectedAll) {
          this.selectedToSendMessage = []
        } else {
          this.showAll.forEach((person) => {
            this.selectedToSendMessage.push(person.id)
          })
        }
      })
    },
    // procurar entidades filhas da entidade
    async lerEntidadeFilhas() {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const entityName = routedEntity.name

      console.log(entityName, "PAI");
      try {
        this.$store.commit('user/UPDATE_LOADING', true)

        let ret = await User.readEntityChild(entityId)
        if (ret.success) {
          
          let actualEntity = [{ id: entityId, name: entityName, father: true }]

          this.allEntities = [...actualEntity, ...ret.data]

          console.log('BEM AQUI',this.allEntities)
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    // enviar mala direta para esta e entidades filhas ativas
    async allParentsActive() {
      this.sendToMsg = 'Enviar para esta entidade e filhas ativas'
      this.advanced = true
      this.selectAllEntities = true
      this.searchEntities = false
      this.selectedToSendMessage = []
      this.selectedEntities = []
      this.$emit('allParentsActive', this.allEntities)
    },

    // enviar mala direta para entidades selecionadas
    async selectEntities() {
      this.sendToMsg = 'Enviar para entidades selecionadas'
      this.advanced = true
      this.searchEntities = true
      this.selectAllEntities = false
      this.selectedToSendMessage = []
      this.$emit('cleanEntities')
    },

    emitSelectedEntities() {
      console.log("olá", this.allEntities);
      this.$emit('selectedEntities', this.selectedEntities)
    },

    // muda para o default de envio (selecionar participantes)
    sendToDefault() {
      this.searchEntities = false
      this.selectAllEntities = false
      this.sendToMsg = 'Enviar para'
      this.advanced = false
      this.selectedEntities = []
      if (this.selectedToSendMessage.length == 0) this.toggle()
    },
  },
}
</script>
<style scoped>
.maxHeightSelectEntities {
  padding-left: 1rem;
  max-height: 20vh;
  overflow-y: auto;
}
</style>
